<source>
  @type tail
  tag camoproxy
  path /var/log/camoproxy/current
  pos_file /var/log/td-agent/camoproxy.log.pos
  <parse>
    # A little bit fragile as it needs to know the list of possible additional fields after 'msg'.
    # The repeated expression (?:[^"\\]|\\.)* is used to capture strings that might contain escaped double quotes
    # The camoproxy logger library can do JSON, but camoproxy doesn't use that.  If we can get that upstream'd (as a flag)
    # we could simplify this to @type json and time_format
    @type regexp
    expression /^[0-9-]{10}_[0-9:.]{14} time="(?<time>[^"]*)" level="(?<camoproxy_level>.)" msg="(?<camoproxy_message>(?:[^"\\]|\\.)*)"( resp="(?<camoproxy_resp>(?:[^"\\]|\\.)*)"| req="(?<camoproxy_req>(?:[^"\\]|\\.)*)"| url="(?<camoproxy_url>(?:[^"\\]|\\.)*)"| err="(?<camoproxy_err>(?:[^"\\]|\\.)*)"| type="(?<camoproxy_type>(?:[^"\\]|\\.)*)")*/
    time_format %Y-%m-%dT%H:%M:%S.%N%Z
  </parse>
</source>

## - add hostname key based on chef metadata
<filter camoproxy>
  @type record_transformer
  <record>
<%= render "partial_default_record_attributes.erb" %>
  </record>
</filter>

<match camoproxy>
  @type copy
  <% if node['gitlab_fluentd']['pubsub_enable'] -%>
  <store>
    @type cloud_pubsub
    topic pubsub-camoproxy-inf-<%= node['gitlab_fluentd']['pubsub_env'] %>
    project <%= node['gitlab_fluentd']['pubsub_project'] %>
    <% if node['gitlab_fluentd']['pubsub_key'] -%>
    key <%= node['gitlab_fluentd']['pubsub_file'] %>
    <% end -%>
  </store>
  <% end -%>

<%= render "partial_stackdriver.erb" %>
  @include ../prometheus-mixin.conf
</match>

